		.title		HLK/ev (main.s - main control module)

program:	.reg		'HLK evolution'
version:	.reg		'3.01+1'
date:		.reg		'97/05/27'
author:		.reg		'Ԃq'


* Include File -------------------------------- *

		.include	hlk.mac
		.include	string.mac
		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref		init_arg
		.xref		hup_get_arg
		.xref		fget_arg

		.xref		init_hash

		.xref		search_xdef

		.xref		get_object
		.xref		get_object2
		.xref		regist_object
		.xref		do_request
		.xref		activate_xdef
		.xref		search_and_link
		.xref		set_xdef_value
		.xref		set_xref_value
		.xref		calc_roff_sz
		.xref		make_exe
		.xref		make_map

		.xref		argc
		.xref		argv
		.xref		arg_size
		.xref		arg_buf


* Fixed Number -------------------------------- *

MAX_ARGC:	.equ		4096
STACK_SIZE:	.equ		32*1024
CALC_STACK_SIZE:.equ		1024


* Text Section -------------------------------- *

		.cpu		68000

		.text
		.even

		_obj_list_	obj_list,a0,0
		_link_list_	link_list,a1,0
		_xdef_list_	xdef_list,a0,0

main:
		bra.s		@f
		.dc.b		'#HUPAIR',0
		.even
@@:
		lea		(16,a0),a0
		suba.l		a0,a1
		adda.l		#STACK_SIZE,a1
		move.l		a1,-(sp)
		move.l		a0,-(sp)
		DOS		_SETBLOCK
		addq.l		#8,sp
		tst.l		d0
		bmi		malloc_err
		lea		(a0,a1.l),sp

		lea		(obj_list_head,pc),a0
		move.l		a0,(obj_list_wp-obj_list_head,a0)
		lea		(link_list_head,pc),a0
		move.l		a0,(link_list_wp-link_list_head,a0)

		pea		(MAX_ARGC*4+4)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		malloc_err
		move.l		d0,d2			;d2.l = argv_buf

		bsr		malloc_all
		tst.l		d0
		bmi		malloc_err

		move.l		d0,-(sp)		;arg_buf
		move.l		d2,-(sp)		;argv_buf
		move.l		d1,-(sp)		;arg_buf_size
		pea		(MAX_ARGC)		;max_argc
		bsr		init_arg
		lea		(16,sp),sp

		lea		(temp,pc),a0
		move.l		a0,-(sp)
		clr.l		-(sp)
		pea		(env_hlkev,pc)
		DOS		_GETENV
		addq.l		#12-4,sp
		move.l		d0,(sp)+
		bmi		@f
		move.l		a0,-(sp)
		bsr		hup_get_arg
		move.l		d0,(sp)+
		bmi		main_err1		;too many argumets
@@:
		pea		(1,a2)
		bsr		hup_get_arg
		move.l		d0,(sp)+
		beq		print_usage
		bmi		main_err1		;too many argumets

		bsr		analyze_opt
		move		(exit_code,pc),d0
		bne		main_end

		move.b		(title_flag,pc),d0
		beq		@f
		move		#STDERR,-(sp)
		pea		(title_msg,pc)
		DOS		_FPUTS
		addq.l		#6,sp
@@:
		move.l		(arg_buf,pc),a0
		move.l		(arg_size,pc),d0
		ori		#$00ff,d0
		addq.l		#1,d0
		move.l		d0,-(sp)
		pea		(a0)
		DOS		_SETBLOCK
		addq.l		#8,sp

		bsr		init_hash

		bsr		malloc_all
		tst.l		d0
		bmi		malloc_err

		move.l		d0,d2			;d0.l = malloc_ptr_head
		add.l		d1,d2			;d2.l = malloc_ptr_tail
							;d1.l = malloc_left

		moveq		#16*6,d3		;Cx
		sub.l		d3,d1
		bmi		malloc_err
		add.l		d3,d0			;d0.l = calc_stack_top
		lea		(calc_stack_top,pc),a0
		move.l		d0,(a0)

		move.l		#CALC_STACK_SIZE*6,d3
		sub.l		d3,d1
		bmi		malloc_err
		add.l		d3,d0			;d0.l = calc_stack_bot
		move.l		d0,(calc_stack_bot-calc_stack_top,a0)
		move.l		d0,(calc_stack_ptr-calc_stack_top,a0)

		moveq		#16*6,d3		;Cx
		sub.l		d3,d1			;d1.l = malloc_left
		bmi		malloc_err
		add.l		d3,d0			;d0.l = headder_adr

		lea		(malloc_ptr_head,pc),a0
		move.l		d0,(a0)+		;malloc_ptr_head
		move.l		d2,(a0)+		;malloc_ptr_tail
		move.l		d1,(a0)+		;malloc_left

		bsr		analyze_opt2

		movea.l		(argv,pc),a1
		tst.l		(a1)
		beq		print_usage
main_l30:	move.l		(a1)+,d1		;read object & make xdef
		beq		main_b35
		movea.l		d1,a0
		cmp.b		#'+',(a0)+
		bne		main_l30

		bsr		get_object
		tst.l		d0
		ble		main_l30

		bsr		print_already_msg
		bra		main_l30

main_b35:	movea.l		(argv,pc),a1
		tst.l		(a1)
		beq		print_usage
main_l35:	move.l		(a1)+,d1		* read object & make xdef
		beq		main_b40
		movea.l		d1,a0
		cmp.b		#'+',(a0)
		beq		main_l35
		bsr		get_object
		tst.l		d0
		ble		main_l35

		bsr		print_already_msg
		bra		main_l35

main_b40:	move.l		(obj_list_head,pc),d0
		beq		main_end

* IuWFNgw肳ĂȂ΃G[A-sIvVw莞
* ZNVp̉zIuWFNgK̂ŁA̎
* IuWFNg݂邩ǂ𒲂ׂ.

		move.b		(mk_sz_info_flag,pc),d1
		beq		@f
		movea.l		d0,a0
		tst.l		obj_list_next
		beq		main_end
@@:
		move.l		(obj_list_head,pc),d0	;link object
*		beq		main_end
main_l40:
		movea.l		d0,a0			;a0.l = obj_list
		tst.l		obj_list_lib_name
		bne		main_b41
		bsr		regist_object
main_b41:
		move.l		obj_list_next,d0
		bne		main_l40

		move.l		(link_list_head,pc),d0
		beq		print_usage
		movea.l		d0,a1
		move.l		link_list_obj_list,a0
		move.l		(sys_info_adr,pc),d0
		cmp.l		obj_list_obj_image,d0
		bne		main_b51
		tst.l		link_list_next
		beq		print_usage

main_b51:	bsr		make_exec_name
		bsr		make_map_name

		move.l		(link_list_head,pc),d0	;do request
main_l50:
		movea.l		d0,a1			;a1.l = link_list
		movea.l		link_list_obj_list,a0	;a0.l = obj_list
		bsr		do_request
		move.l		link_list_next,d0
		bne		main_l50

		move.l		(link_list_head,pc),d0	;search xref & link
main_l60:
		movea.l		d0,a1			;a1.l = link_list
		movea.l		link_list_obj_list,a0	;a0.l = obj_list
		bsr		activate_xdef
		bsr		search_and_link
		move.l		link_list_next,d0
		bne		main_l60

		move		(exit_code,pc),d0
		bne		main_end

* ̎_ŕKvȃIuWFNg͑Sēǂݍ܂Ă.

* IuWFNgƂ̃AC␳͂܂sĂ炸AZNVTCY
* vZĂȂ̂ŁAŌvZ. ݈ʒuɌvZĂ.
* ZNVɃIuWFNg̒OŃAC␳sĂ̂ŁA
* ZNVTCY̍őACTCYւ̕␳͕sv.

		lea		(calc_obj_pos,pc),a3
		moveq		#0,d0			;d0.l = text_pos

		lea		(calc_obj_pos_text,pc),a4
		lea		(text_size,pc),a2
		jsr		(a3)

		lea		(calc_obj_pos_data,pc),a4
		lea		(data_size,pc),a2
		jsr		(a3)

		lea		(calc_obj_pos_rdata,pc),a4
		lea		(rdata_d_size,pc),a2	;̂̃TCY
		jsr		(a3)

		lea		(calc_obj_pos_rldata,pc),a4
		lea		(rldata_d_size,pc),a2	;̂̃TCY
		jsr		(a3)

		lea		(calc_obj_pos_bss,pc),a4
		lea		(bss_size,pc),a2
		jsr		(a3)

*		lea		(calc_obj_pos_common,pc),a4
*		lea		(common_size,pc),a2
*		jsr		(a3)

		lea		(calc_obj_pos_stack,pc),a4
		lea		(stack_size,pc),a2
		jsr		(a3)

		move.l		#-32768,d0		;d0.l = rdata_pos

		lea		(calc_obj_pos_rdata,pc),a4
		lea		(rdata_size,pc),a2
		jsr		(a3)

		lea		(calc_obj_pos_rbss,pc),a4
		lea		(rbss_size,pc),a2
		jsr		(a3)

*		lea		(calc_obj_pos_rcommon,pc),a4
*		lea		(rcommon_size,pc),a2
*		jsr		(a3)

		lea		(calc_obj_pos_rstack,pc),a4
		lea		(rstack_size,pc),a2
		jsr		(a3)

		lea		(calc_obj_pos_rldata,pc),a4
		lea		(rldata_size,pc),a2
		jsr		(a3)

		lea		(calc_obj_pos_rlbss,pc),a4
		lea		(rlbss_size,pc),a2
		jsr		(a3)

*		lea		(calc_obj_pos_rlcommon,pc),a4
*		lea		(rlcommon_size,pc),a2
*		jsr		(a3)

		lea		(calc_obj_pos_rlstack,pc),a4
		lea		(rlstack_size,pc),a2
		jsr		(a3)

		move.b		(mk_sz_info_flag,pc),d0
		beq		main_b71
		move.l		(rdata_size,pc),d0
		add.l		(rbss_size,pc),d0
		add.l		(rcommon_size,pc),d0
		add.l		(rstack_size,pc),d0
		add.l		(rldata_size,pc),d0
		add.l		(rlbss_size,pc),d0
		add.l		(rlcommon_size,pc),d0
		add.l		(rlstack_size,pc),d0
		lea		(rsize_lbl_name,pc),a0
		move.l		d0,(rsize_lbl+2-rsize_lbl_name,a0)

		bsr		search_xdef
		move.l		d0,a0
		move.l		(rsize_lbl+2,pc),xdef_list_value

main_b71:	move.l		(link_list_head,pc),d0	;set xref value
main_l70:
		movea.l		d0,a1			;a1.l = link_list
		movea.l		link_list_obj_list,a0	;a0.l = obj_list
		bsr		set_xref_value
		move.l		link_list_next,d0
		bne		main_l70

		move		(exit_code,pc),d0
		bne		main_end

* ΃ItZbge[ũTCY߂.
* f[^TCYɂ͊܂܂Ȃ̂ŁAKvɉčv.

		bsr		calc_roff_sz

* IuWFNgPʂ̍Ƃ͏IĂ̂ŁA
* obj_sizey(rl)common_pošvẐ.

		move.l		(text_size,pc),d0
		add.l		(data_size,pc),d0
		add.l		(rdata_d_size,pc),d0	;̂̃TCY
		add.l		(rldata_d_size,pc),d0	;V
		add.l		(roff_tbl_size,pc),d0
		lea		(obj_size,pc),a0	;Pmake_exeœvZ
		move.l		d0,(a0)			;̂ȗĂ邾...
		add.l		(bss_size,pc),d0
		lea		(common_pos,pc),a0
		move.l		d0,(a0)+

		move.l		#-32768,d0
		add.l		(rdata_size,pc),d0
		add.l		(rbss_size,pc),d0
		move.l		d0,(a0)+		;rcommon_pos

		add.l		(rcommon_size,pc),d0
		add.l		(rstack_size,pc),d0
		add.l		(rldata_size,pc),d0
		add.l		(rlbss_size,pc),d0
		move.l		d0,(a0)			;rlcommon_pos

		move.l		(link_list_head,pc),d0	;set xdef value
main_l100:
		movea.l		d0,a1			;a1.l = link_list
		movea.l		link_list_obj_list,a0	;a0.l = obj_list
		bsr		set_xdef_value
		move.l		link_list_next,d0
		bne		main_l100

		move		(exit_code,pc),d0
		beq		@f
		bsr		print_crlf
@@:
		bsr		make_exe

		move.b		(mk_map_flag,pc),d0
		beq		main_end
		bsr		make_map
main_end:
		move		(exit_code,pc),-(sp)
		DOS		_EXIT2



* IuWFNg̒ÕAC␳yуZNVTCY̌vZ.

		_obj_list_	obj_list,a0,0
		_link_list_	link_list,a1,0

calc_obj_pos:
		move.l		d0,d2
		move.l		(link_list_head,pc),d1
		beq		calc_obj_pos_end
calc_obj_pos_loop:
		movea.l		d1,a1			;a1.l = link_list
		movea.l		link_list_obj_list,a0	;a0.l = obj_list

		jsr		(a4)			;sectionpos,sizeZ

		move.l		link_list_next,d1
		bne		calc_obj_pos_loop
calc_obj_pos_end:
		move.l		d0,d1
		sub.l		d2,d1			;ZNVTCY
		move.l		d1,(a2)
		rts

calc_obj_pos_text:
		tst.b		obj_list_xdef_01
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_text_pos
		add.l		obj_list_text_size,d0
		rts
calc_obj_pos_data:
		tst.b		obj_list_xdef_02
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_data_pos
		add.l		obj_list_data_size,d0
		rts
calc_obj_pos_bss:
		tst.b		obj_list_xdef_03
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_bss_pos
		add.l		obj_list_bss_size,d0
		rts
*calc_obj_pos_common:
*		tst.b		obj_list_xdef_fe
*		beq		@f
*		bsr		align_d0
*@@:		move.l		d0,obj_list_common_pos
*		add.l		obj_list_common_size,d0
*		rts
calc_obj_pos_stack:
		tst.b		obj_list_xdef_04
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_stack_pos
		add.l		obj_list_stack_size,d0
		rts

calc_obj_pos_rdata:
		tst.b		obj_list_xdef_05
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rdata_pos
		add.l		obj_list_rdata_size,d0
		rts
calc_obj_pos_rbss:
		tst.b		obj_list_xdef_06
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rbss_pos
		add.l		obj_list_rbss_size,d0
		rts
*calc_obj_pos_rcommon:
*		tst.b		obj_list_xdef_fc
*		beq		@f
*		bsr		align_d0
*@@:		move.l		d0,obj_list_rcommon_pos
*		add.l		obj_list_rcommon_size,d0
*		rts
calc_obj_pos_rstack:
		tst.b		obj_list_xdef_07
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rstack_pos
		add.l		obj_list_rstack_size,d0
		rts

calc_obj_pos_rldata:
		tst.b		obj_list_xdef_08
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rldata_pos
		add.l		obj_list_rldata_size,d0
		rts
calc_obj_pos_rlbss:
		tst.b		obj_list_xdef_09
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rlbss_pos
		add.l		obj_list_rlbss_size,d0
		rts
*calc_obj_pos_rlcommon:
*		tst.b		obj_list_xdef_fd
*		beq		@f
*		bsr		align_d0
*@@:		move.l		d0,obj_list_rlcommon_pos
*		add.l		obj_list_rlcommon_size,d0
*		rts
calc_obj_pos_rlstack:
		tst.b		obj_list_xdef_0a
		beq		@f
		bsr		align_d0
@@:		move.l		d0,obj_list_rlstack_pos
		add.l		obj_list_rlstack_size,d0
		rts


		_obj_list_	obj_list,a0,0

align_d0::
		move.l		d1,-(sp)
		move.l		obj_list_align_size,d1
		subq.l		#1,d1			* d1.l = (align - 1)
		add.l		d1,d0
		not.l		d1
		and.l		d1,d0
		move.l		(sp)+,d1
		rts


*------------------------------------------------------------------------------
*
*	already read
*
*------------------------------------------------------------------------------

print_already_msg:
		pea		(already_msg,pc)	;already read
		DOS		_PRINT
		move.l		d1,-(sp)
		DOS		_PRINT
		addq.l		#8,sp
		bra		print_crlf
*		rts

*------------------------------------------------------------------------------
*
*	too many arguments
*
*------------------------------------------------------------------------------

main_err1	pea		(too_many_args,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move		#-1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	print_usage
*
*------------------------------------------------------------------------------

print_usage:
		move.b		(title_flag,pc),d0
		bne		print_usage_b

		pea		(title_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp

print_usage_b:	pea		(usage_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp

		move		#1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	program_err
*
*	in:	a0.l = function adr
*
*	͏oė~Ȃ(^_^;
*
*------------------------------------------------------------------------------

program_err::
		pea		(prog_err_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move.l		a0,d0
		pea		(main,pc)
		sub.l		(sp)+,d0		;vZX擪̃ItZbg
		bsr		print_hex8
		bsr		print_crlf
		pea		(prog_err_msg2,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move		#-1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	malloc_all
*
*	out:	d0.l	Ǘ|C^
*		d1.l	mۂł̃TCY
*
*	mۂł邾
*	Ŝߊmۂł̃TCY͂PjoCgȂ
*	mۂ郁̑傫́An*$100oCg
*
*	error:	d0.l	< 0	sĂ
*
*------------------------------------------------------------------------------

malloc_all:
		pea		($ffff00)
		DOS		_MALLOC
		and.l		(sp)+,d0
		subi.l		#1024,d0
		bmi		@f

		move.l		d0,-(sp)
		DOS		_MALLOC
		move.l		(sp)+,d1		;d1.l = malloc size
@@:		rts


*------------------------------------------------------------------------------
*
*	malloc_err
*
*------------------------------------------------------------------------------

malloc_err::
		pea		(malloc_err_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move		#-1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	unknown_cmd
*
*	a0.l = unknown command ptr
*	a1.l = obj_list
*
*------------------------------------------------------------------------------

		_obj_list_	obj_list,a1,0

unknown_cmd::
		pea		(unknown_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move		(a0),d0
		bsr		print_hex4
		pea		(at_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move.l		a0,d0
		sub.l		obj_list_obj_image,d0
		bsr		print_hex8
		bsr		print_crlf

		pea		(in_msg,pc)
		DOS		_PRINT
		move.l		obj_list_obj_name,-(sp)
		DOS		_PRINT
		addq.l		#8,sp

		move.l		obj_list_lib_name,d1
		beq		unknown_cmd_end
		pea		(in_msg,pc)
		DOS		_PRINT
		move.l		d1,-(sp)
		DOS		_PRINT
		addq.l		#8,sp
unknown_cmd_end:
		bsr		print_crlf

		move		#-1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	analyze_opt
*
*	-d ȊÕIvV]ăR}hC폜܂
*
*------------------------------------------------------------------------------

analyze_opt:
		PUSH		d1-d2/a0-a5

		lea		(argc,pc),a0		;a0.l = argc
		movea.l		(argv,pc),a1		;a1.l = argv
ana_opt_l10:	move.l		(a1)+,d0
		beq		ana_opt_end
		movea.l		d0,a2			;a2.l = arg
		cmpi.b		#'-',(a2)+
		bne		ana_opt_l10
		bra		ana_opt_loop
ana_opt_next:
		tst.b		(a2)
		beq		ana_opt_l10
ana_opt_loop:
		moveq		#$20,d0
		or.b		(a2)+,d0
		cmpi.b		#'d',d0
		beq		ana_opt_l10		;-d͌ŏ̂ŎcĂ

		cmpi.b		#'-',(-2,a2)
		bne		@f
		subq.l		#4,a1
		movea.l		a1,a4
ana_opt_l11:	move.l		(4,a4),(a4)+
		bne		ana_opt_l11
		subq.l		#1,(a0)			;delete arg
@@:
		cmpi.b		#'?',d0
		beq		print_usage
		subi.b		#'a',d0
		cmpi.b		#'z'-'a',d0
		bhi		ana_opt_b30
		add		d0,d0
		move		(@f,pc,d0.w),d0
		jmp		(@f,pc,d0.w)
@@:
		.dc		ana_opt_b650-@b		;-a = no 'x' ext.
		.dc		option_b_baseadr-@b	;-b = base address
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b700-@b		;-e = set align
		.dc		ana_opt_b30-@b
		.dc		option_g_loadmode-@b	;-g = load mode
		.dc		print_usage-@b		;-h = help
		.dc		ana_opt_b150-@b		;-i = indirect
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b200-@b		;-l = lib path
		.dc		ana_opt_b250-@b		;-m = max label
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b300-@b		;-o = obj name
		.dc		ana_opt_b350-@b		;-p = map
		.dc		ana_opt_b30-@b
		.dc		option_r_rtype-@b	;-r = .r type exec file
		.dc		option_s_secinfo-@b	;-s = link secsion info
		.dc		ana_opt_b600-@b		;-t = print title
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b400-@b		;-v = verbose
		.dc		ana_opt_b450-@b		;-w = warning off
		.dc		ana_opt_b500-@b		;-x = symbol cut
		.dc		ana_opt_b30-@b
		.dc		ana_opt_b550-@b		;-z = verbose off

ana_opt_b30:	pea		(unknown_opt_msg,pc)	;unknown option
		DOS		_PRINT
		bsr		ana_opt_print_arg
ana_opt_err_next:
		addq.l		#4,sp
		bsr		print_crlf
		lea		(exit_code,pc),a2
		move		#-1,(a2)
		bra		ana_opt_l10

ana_opt_print_arg:
		move.l		a2,-(sp)
@@:		cmpi.b		#'-',-(a2)
		bne		@b
		move.l		a2,-(sp)
		DOS		_PRINT
		addq.l		#4,sp
		movea.l		(sp)+,a2
		rts

ana_opt_b40:	pea		(bad_opt_msg,pc)	;bad option
		DOS		_PRINT
		bsr		ana_opt_print_arg
		tst.b		(a2)
		bne		ana_opt_err_next

		bsr		print_spc
		move.l		a3,(sp)
		DOS		_PRINT
		bra		ana_opt_err_next

ana_opt_b50:	pea		(bad_opt_msg,pc)	;bad option
		DOS		_PRINT
		bsr		ana_opt_print_arg
		bra		ana_opt_err_next

ana_opt_b60:	pea		(undef_env_lib,pc)	;undefined env. value 'lib'
		DOS		_PRINT
		addq.l		#4,sp
		bra		ana_opt_next

ana_opt_end:
		POP		d1-d2/a0-a5
		rts


* -i file (indirect)
ana_opt_b150:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option

		lea		(indir_flag,pc),a4
		tas		(a4)
		bne		indir_mode_err		;dws

		clr		-(sp)
		pea		(a3)
		DOS		_OPEN
		addq.l		#6,sp
		tst.l		d0
		bmi		indir_open_err		;indir open error
		move.l		d0,d1

		move.l		d1,-(sp)
		bsr		fget_arg
		addq.l		#4,sp
		move.l		d0,d2

		move		d1,-(sp)
		DOS		_CLOSE
		addq.l		#2,sp

		tst.l		d2
		bmi		main_err1		;too many arguments error
		bra		ana_opt_l10


* -l (lib path)
ana_opt_b200:
		lea		(search_path,pc),a4
		pea		(a4)
		clr.l		-(sp)
		pea		(env_lib,pc)
		DOS		_GETENV
		addq.l		#12-4,sp
		move.l		d0,(sp)+
		bmi		ana_opt_b60		;undefined env. value 'lib'

@@:		tst.b		(a4)+
		bne		@b
		subq.l		#2,a4
		move.b		(a4)+,d1

		moveq		#'\',d0			;'\'⊮
		cmp.b		d0,d1
		beq		ana_opt_l10
		cmpi.b		#'/',d1
		beq		ana_opt_l10
		cmpi.b		#':',d1
		beq		ana_opt_l10
		move.b		d0,(a4)+
		clr.b		(a4)
		bra		ana_opt_next


* -m num (max label)
ana_opt_b250:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option
		bsr		get_number
		bmi		ana_opt_b40		;bad option

		bra		ana_opt_l10		;l𖳎邾


* -o file (obj name)
ana_opt_b300:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option

		moveq		#96-1,d0
		movea.l		a3,a4
		lea		(exec_name,pc),a5
@@:		move.b		(a4)+,(a5)+
		dbeq		d0,@b
		beq		ana_opt_l10
		bra		ana_opt_b40		;bad option


* -p [file] (map)
ana_opt_b350:
		lea		(mk_map_flag,pc),a4
		st		(a4)
		clr.b		(map_name-mk_map_flag,a4)

		bsr		get_arg_adr
		beq		ana_opt_l10		;t@C͏ȗ\

		moveq		#96-1,d0
		movea.l		a3,a4
		lea		(map_name,pc),a5
@@:		move.b		(a4)+,(a5)+
		dbeq		d0,@b
		lea		(mk_map_flag,pc),a4
		seq		(a4)
		beq		ana_opt_l10
		bra		ana_opt_b40		;bad option


* -z (verbose off)
ana_opt_b550:	lea		(verbose_flag,pc),a4
		sf		(a4)
		bra		ana_opt_next


* -v (verbose)
ana_opt_b400:	lea		(verbose_flag,pc),a4
		st		(a4)
		bra		ana_opt_next


* -w (warning off)
ana_opt_b450:	lea		(warnoff_flag,pc),a4
		st		(a4)
		bra		ana_opt_next


* -x (symbol cut)
ana_opt_b500:	lea		(cut_sym_flag,pc),a4
		st		(a4)
		bra		ana_opt_next


* -t (print title)
ana_opt_b600:	lea		(title_flag,pc),a4
		st		(a4)
		bra		ana_opt_next


* -a (no 'x' ext.)
ana_opt_b650:	lea		(no_x_ext_flag,pc),a4
		bra		ana_opt_check_an_rn

* -r / -rn (.r type exec file)
option_r_rtype:
		lea		(exec_file_type,pc),a4
		bra		ana_opt_check_an_rn

ana_opt_check_an_rn:
		st		(a4)+
		moveq		#$20,d0
		or.b		(a2)+,d0
		cmpi.b		#'n',d0
		seq		(a4)			;opt_[ar]n_flag
		beq		@f
		subq.l		#1,a2
@@:		bra		ana_opt_next


* -e num (set align)
ana_opt_b700:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option
		bsr		get_number
		bmi		ana_opt_b40		;bad option

		cmpi.l		#256,d0
		bhi		ana_opt_b40
		cmpi		#2,d0
		bcs		ana_opt_b40		;2`256,2^nłȂ΃G[

		move		d0,d1
@@:		lsr		#1,d1
		bcc		@b
		bne		ana_opt_b40

		lea		(align_size,pc),a4
		move.l		d0,(a4)
		bra		ana_opt_l10


* -s (option_s_secinfo)
option_s_secinfo:
		lea		(mk_sz_info_flag,pc),a4
		st		(a4)
		bra		ana_opt_next


* -b num (base address)
option_b_baseadr:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option
		bsr		get_number
		bmi		ana_opt_b40		;bad option

		lea		(base_address,pc),a4
		move.l		d0,(a4)
		bra		ana_opt_l10


* -g num (load mode)
option_g_loadmode:
		bsr		get_arg_adr
		beq		ana_opt_b50		;bad option
		bsr		get_number
		bmi		ana_opt_b40		;bad option

		moveq		#2,d1
		cmp.l		d1,d0
		bhi		ana_opt_b40		;bad option

		lea		(loadmode,pc),a4
		move.b		d0,(a4)
		bra		ana_opt_l10


* IvV̈Ďw肳ꂽꍇÃAhX𓾂.
* ĂȂ炻̂܂.
* in	a0.l	argcւ̃|C^
*	a1.l	̈AhXւ̃|C^(0Ȃ̏I)
*	a2.l	IvṼAhX
* out	a3.l	̃AhX
*	ccr	Z=0:I Z=1:G[(ȏȂ)
* break	d0/a4

get_arg_adr:
		movea.l		a2,a3
		tst.b		(a2)
		bne		get_arg_adr_end

		move.l		(a1),d0
		beq		get_arg_adr_end
		movea.l		d0,a3
		cmpi.b		#'-',(a3)
		beq		get_arg_adr_end
		movea.l		a1,a4
@@:		move.l		(4,a4),(a4)+
		bne		@b
		subq.l		#1,(a0)			;delete arg
get_arg_adr_end:
		rts


* l(10i/16i)
* in	a3.l	̃AhX
* out	d0.l	l
*	ccr	N=0/Z=1:I N=1/Z=0:G[

get_number::
		PUSH		d1/a4
		moveq		#0,d0
		moveq		#0,d1
		movea.l		a3,a4
		move.b		(a4)+,d1
		beq		get_number_error
		cmpi.b		#'$',d1
		beq		get_num_hex		;$*
		cmpi.b		#'9',d1
		bhi		get_number_error
		cmpi.b		#'0',d1
		bcs		get_number_error
		bhi		get_num_dec		;[1-9]*
		moveq		#$20,d1
		or.b		(a4)+,d1
		cmpi.b		#'x',d1
		beq		get_num_hex		;0x*

		subq.l		#1,a4			;0[1-9]*
get_num_dec:	subq.l		#1,a4
get_num_dec_loop:
		move.b		(a4)+,d1
		beq		get_number_end
		subi.b		#'0',d1
		cmpi.b		#9,d1
		bhi		get_number_error
		cmpi.l		#429496729.5,d0		;$ffff_ffff/10
		bhi		get_number_error
		add.l		d0,d0
		move.l		d0,-(sp)
		lsl.l		#2,d0
		add.l		(sp)+,d0		;*10
		add.l		d1,d0
		bcc		get_num_dec_loop
get_number_error:
		moveq		#-1,d1
		bra		@f
get_number_end:
		moveq		#0,d1
@@:		POP		d1/a4
		rts

get_num_hex:
		move.b		(a4)+,d1
		beq		get_number_error
get_num_hex_loop:
		cmpi.b		#'9',d1
		bls		@f
		andi.b		#$df,d1
		cmpi.b		#'A',d1
		bcs		get_number_error
		subq.b		#'A'-('9'+1),d1
@@:		subi.b		#'0',d1
		cmpi.b		#$f,d1
		bhi		get_number_error
		cmpi.l		#$0fff_ffff,d0
		bhi		get_number_error
		lsl.l		#4,d0
		or.b		d1,d0
		move.b		(a4)+,d1
		bne		get_num_hex_loop
		bra		get_number_end


* G[I

indir_mode_err:	pea		(indir_err_msg,pc)
		DOS		_PRINT
		addq.l		#4,sp
		move		#-1,-(sp)
		DOS		_EXIT2

indir_open_err:	pea		(nf_indir_msg,pc)
		DOS		_PRINT
		pea		(a3)
		DOS		_PRINT
		addq.l		#8,sp
		bsr		print_crlf
		move		#-1,-(sp)
		DOS		_EXIT2


*------------------------------------------------------------------------------
*
*	analyze_opt2
*
*	IvV -d ]ăR}hC폜܂
*
*------------------------------------------------------------------------------

analyze_opt2:
		PUSH		d1-d2/d6-d7/a0-a5

		movea.l		(malloc_ptr_head,pc),a5	;a5.l = malloc_ptr_head
		move.l		(malloc_left,pc),d7	;d7.l = malloc_left

		lea		(argc,pc),a0		;a0.l = argc
		movea.l		(argv,pc),a1		;a1.l = argv
ana_opt2_l10:	move.l		(a1)+,d0
		beq		ana_opt2_b60
		movea.l		d0,a2			;a2.l = arg
		cmpi.b		#'-',(a2)+
		bne		ana_opt2_l10

		subq.l		#4,a1
		movea.l		a1,a4
ana_opt2_l11:	move.l		(4,a4),(a4)+
		bne		ana_opt2_l11
		subq.l		#1,(a0)			;delete arg

*		moveq		#$20,d0
*		or.b		(a2)+,d0
*		cmpi.b		#'d',d0
*		beq		ana_opt2_b150

		addq.l		#1,a2
		bra		ana_opt2_b150		;-d

*ana_opt2_b30:	pea		(unknown_opt_msg,pc)	;unknown option
*		DOS		_PRINT
*		addq.l		#4,sp
*		bsr		ana_opt_print_arg
*		bra		ana_opt2_err_next

*ana_opt2_b40:	pea		(bad_opt_msg,pc)	;bad option
*		DOS		_PRINT
*		addq.l		#4,sp
*		bsr		ana_opt_print_arg
*		tst.b		(a2)
*		bne		@f
*		bsr		print_spc
*		pea		(a3)
*		DOS		_PRINT
*		addq.l		#4,sp
*@@:		bra		ana_opt2_err_next

ana_opt2_b50:	pea		(bad_opt_msg,pc)	;bad option
		DOS		_PRINT
		addq.l		#4,sp
		bsr		ana_opt_print_arg
*ana_opt2_err_next:
		bsr		print_crlf
		lea		(exit_code,pc),a2
		move		#-1,(a2)
		bra		ana_opt2_l10

;I
ana_opt2_b60:	move.b		(mk_sz_info_flag,pc),d0
		beq		ana_opt2_b80

		move.l		(sys_info_adr,pc),d0
		bne		ana_opt2_b70

		move.l		#sys_info_h_len+2,d0
		sub.l		d0,d7
		bmi		malloc_err

		lea		(sys_info_adr,pc),a4
		move.l		a5,(a4)
		lea		(sys_info_h,pc),a4
		subq.l		#3,d0
ana_opt2_l61:	move.b		(a4)+,(a5)+
		dbra		d0,ana_opt2_l61

ana_opt2_b70:	move.l		#sz_info_lbl_sz,d0
		sub.l		d0,d7
		bmi		malloc_err

		lea		(sz_info_lbl,pc),a4
		subq.l		#1,d0
ana_opt2_l70:	move.b		(a4)+,(a5)+
		dbra		d0,ana_opt2_l70

		move.l		#rsize_lbl_sz,d0
		sub.l		d0,d7
		bmi		malloc_err

		lea		(rsize_lbl,pc),a4
		subq.l		#1,d0
ana_opt2_l71:	move.b		(a4)+,(a5)+
		dbra		d0,ana_opt2_l71

		moveq		#12,d0
		sub.l		d0,d7
		bmi		malloc_err

		move		#$2002,(a5)+
		clr.l		(a5)+
		move		#$3000,(a5)+
		moveq		#$40,d0
		move.l		d0,(a5)+
		clr		(a5)

		movea.l		(sys_info_adr,pc),a0
		move.l		d0,($1e,a0)

ana_opt2_b80:	move.l		(sys_info_adr,pc),d0
		beq		ana_opt2_b81
		addq.l		#2,a5

ana_opt2_b81:	lea		(malloc_ptr_head,pc),a0
		move.l		a5,(a0)
		move.l		d7,(malloc_left-malloc_ptr_head,a0)

		move.l		(sys_info_adr,pc),d0
		beq		ana_opt2_end

		sub.l		a5,d0
		neg.l		d0
		lea		(sys_info_size,pc),a0
		move.l		d0,(a0)

		move.l		(sys_info_size,pc),d7
		lea		(sys_info_name,pc),a0
		movea.l		a0,a1
		movea.l		(sys_info_adr,pc),a2
		bsr		get_object2

ana_opt2_end:	POP		d1-d2/d6-d7/a0-a5
		rts


* -d lebel = num (define symbol)
ana_opt2_b150:
		bsr		get_arg_adr
		beq		ana_opt2_b50		;bad option

		lea		(sys_info_adr,pc),a4
		tst.l		(a4)
		bne		ana_opt2_b160

		move.l		#sys_info_h_len+2,d0
		sub.l		d0,d7
		bmi		malloc_err

		move.l		a5,(a4)
		lea		(sys_info_h,pc),a4
		subq.l		#1+2,d0			;$00_00͓]Ȃ
ana_opt2_l151:	move.b		(a4)+,(a5)+
		dbra		d0,ana_opt2_l151

ana_opt2_b160:	moveq		#6,d0
		sub.l		d0,d7
		bmi		malloc_err

		move		#$b200,(a5)+
		movea.l		a5,a4			;a4.l = label vaule ptr
		clr.l		(a5)+

ana_opt2_l170:	move.b		(a3)+,d6
		beq		ana_opt2_b180		;bad option
		cmpi.b		#'=',d6
		beq		ana_opt2_b180
		subq.l		#1,d7
		bmi		malloc_err
		move.b		d6,(a5)+		;V{
		bra		ana_opt2_l170

ana_opt2_b180:	subq.l		#1,d7
		bmi		malloc_err
		clr.b		(a5)+
		move		a5,d0
		lsr		#1,d0
		bcc		@f
		subq.l		#1,d7
		bmi		malloc_err
		clr.b		(a5)+			;even
@@:		clr		(a5)

		tst.b		d6			;'='ŏIĂȂ΃G[
		beq		ana_opt2_b50		;bad option

		bsr		get_number
		bmi		ana_opt2_b50		;bad option

		move.l		d0,(a4)
		bra		ana_opt2_l10


*------------------------------------------------------------------------------
*
*	make_exec_name
*
*------------------------------------------------------------------------------

		_obj_list_	obj_list,a0,0
		_link_list_	link_list,a1,0

make_exec_name::
		PUSH		d1/a0-a3
		lea		(exec_name,pc),a0
		movea.l		a0,a2
		move.b		(a0),d1
		bne		mk_exec_name_b2

		movea.l		(link_list_head,pc),a1	;a1.l = link_list_head
		movea.l		link_list_obj_list,a0	;a0.l = obj_list (head)
		move.l		(sys_info_adr,pc),d0
		cmp.l		obj_list_obj_image,d0
		bne		@f
		movea.l		link_list_next,a1
		movea.l		link_list_obj_list,a0	;a0.l = obj_list (head)
@@:		movea.l		obj_list_obj_name,a0	;a0.l = obj_name

mk_exec_name_b2:
		lea		(temp,pc),a3
		pea		(a3)
		pea		(a0)
		DOS		_NAMECK
		addq.l		#8,sp
		_strcpy		(a2),(NAMECK_Drive,a3)
		_strcat		(a2),(NAMECK_Name,a3)

		tst.b		d1
		beq		@f
		lea		(NAMECK_Ext,a3),a0
		tst.b		(a0)
		bne		mk_exname_b3
@@:		lea		(ext_r,pc),a0
		move.b		(exec_file_type,pc),d0
		bne		mk_exname_b3		;-ał".r"͕Kt

		addq.l		#ext_x-ext_r,a0
		tst.b		d1
		bne		@f
		move.b		(opt_an_flag,pc),d0
		bne		mk_exname_b3
@@:		move.b		(no_x_ext_flag,pc),d0
		bne		mk_exname_end
mk_exname_b3:
		_strcat		(a2),(a0)

		lea		(opt_an_flag,pc),a0
		neg.b		(a0)			;=$01Ȃchmod +xȂ(-an)
mk_exname_end:
		POP		d1/a0-a3
		rts

* hlk foo		->	foo.x
* hlk foo -o bar	->	bar.x
* hlk foo	 -a	->	foo	(chmod +x)
* hlk foo -o bar -a	->	bar	(chmod +x)
* hlk foo	 -an	->	foo.x
* hlk foo -o bar -an	->	bar	(chmod +x)

* -an ͎st@Cw莞ɂ.x⊮܂.


*------------------------------------------------------------------------------
*
*	make_map_name
*
*------------------------------------------------------------------------------

		_obj_list_	obj_list,a1,0
		_link_list_	link_list,a1,0

temp2		reg		-256(a6)

make_map_name:
		link		a6,#-256
		PUSH		a0-a2

		move.b		(mk_map_flag,pc),d0
		beq		mk_mapname_end

		lea		map_name(pc),a0
		lea		temp(pc),a2		* a2.l = temp

		tst.b		(a0)
		bne		mk_mapname_b1

		pea		(a2)
		pea		map_name(pc)
		DOS		_NAMECK
		addq.l		#8,sp
		_strcpy		(a0),67(a2)

mk_mapname_b1	lea		temp(pc),a2		* a2.l = temp
		pea		(a2)
		pea		(a0)
		DOS		_NAMECK
		addq.l		#8,sp
		_strcpy		temp2,(a2)
		_strcat		temp2,67(a2)
		tst.b		87(a2)
		beq		mk_mapname_b2
		_strcat		temp2,86(a2)
		bra		mk_mapname_b3

mk_mapname_b2	movea.l		a0,a1
mk_mapname_l	tst.b		(a1)+
		bne		mk_mapname_l
		subq.l		#2,a1

		cmp.b		#'.',(a1)
		beq		mk_mapname_b3
		addq.l		#1,a5
		_strcat		temp2,ext_map(pc)

mk_mapname_b3	_strcpy		(a0),temp2

mk_mapname_end	POP		a0-a2
		unlk		a6
		rts

*------------------------------------------------------------------------------

print_tab::
		move	#TAB,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		rts


print_spc::
		move	#SPACE,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		rts


print_crlf::
		pea	(crlf,pc)
		DOS	_PRINT
		addq.l	#4,sp
		rts

*------------------------------------------------------------------------------
*
*	print_hex2
*
*	in:	d0.l
*
*------------------------------------------------------------------------------

print_hex2::
		PUSH		d1-d2/a0
		moveq		#2-1,d2
		ror.l		#8,d0
		bra		print_hex


*------------------------------------------------------------------------------
*
*	print_hex4
*
*	in:	d0.l
*
*------------------------------------------------------------------------------

print_hex4::
		PUSH		d1-d2/a0
		move		#4-1,d2
		swap		d0
		bra		print_hex


*------------------------------------------------------------------------------
*
*	print_hex8
*
*	in:	d0.l
*
*------------------------------------------------------------------------------

print_hex8::
		PUSH		d1-d2/a0
		moveq		#8-1,d2
		bra		print_hex


print_hex:
		move.l		d0,d1
print_hex_loop:
		rol.l		#4,d1
		moveq		#$f,d0
		and		d1,d0
		move.b		(hex_table,pc,d0.w),d0
		move		d0,-(sp)
		DOS		_PUTCHAR
		addq.l		#2,sp
		dbra		d2,print_hex_loop

		POP		d1-d2/a0
		rts


hex_table::	.dc.b		'0123456789abcdef'
		.even


* Data Section -------------------------------- *

		.data
		.even

align_size::	.dc.l		2

*title_msg:	.dc.b	'X68k SILK Hi-Speed Linker v3.01 Copyright 1989-94 SALT',CRLF
title_msg:	.dc.b	program,' v',version,' Copyright 1989-94 SALT ,',date,' ',author,'.',CRLF
		.dc.b	0

usage_msg:	.dc.b	'usege:	hlk [switch] file [+file] ...',CRLF
		.dc.b	'	-a / -an	st@C̊gqȗ .x tȂ',CRLF
		.dc.b	'	-b num		x[XAhX̐ݒ',CRLF
		.dc.b	'	-d label=num	V{̒`',CRLF
		.dc.b	'	-e num		ACgl̐ݒ',CRLF
		.dc.b	'	-g num		[h[h̐ݒ(0`2)',CRLF
		.dc.b	'	-i file		C_CNgt@C̎w',CRLF
		.dc.b	'	-l		CũpXƂĊϐ lib gp',CRLF
****		.dc.b	'	-m num		őV{̐ݒ()',CRLF
		.dc.b	'	-o file		st@C̎w',CRLF
		.dc.b	'	-p [file]	}bvt@C̍쐬',CRLF
		.dc.b	'	-r / -rn	.r `st@C̍쐬',CRLF
		.dc.b	'	-s		ZNVst@Cɖߍ',CRLF
		.dc.b	'	-t		NɃ^Cg\',CRLF
		.dc.b	'	-v		o[{[Y[h',CRLF
		.dc.b	'	-w		x̏o͋֎~',CRLF
		.dc.b	'	-x		V{e[ȕo͋֎~',CRLF
		.dc.b	'	-z		-v IvV',CRLF
**		.dc.b	'	-z		.z `st@C̍쐬',CRLF
		.dc.b	CRLF
		.dc.b	'	ϐ HLK ̓eR}hC̎Oɑ}܂.',CRLF
		.dc.b	'	t@C擪 + IuWFNg擪ɃN܂.',CRLF
		.dc.b	0

too_many_args:	.dc.b		'Too many arguments',CRLF
		.dc.b		0

prog_err_msg:	.dc.b		'Internal error at : '
		.dc.b		0

prog_err_msg2:	.dc.b		'̃G[̓vÕoOɂĔ\łD',CRLF
		.dc.b		'҂ɂm点Dł̎͂Ă݂܂D(;_;)',CRLF
		.dc.b		CRLF
		.dc.b		0

malloc_err_msg:	.dc.b		'Out of memory !! (_;',CRLF
		.dc.b		0

unknown_opt_msg:.dc.b		'Unknown option : '
		.dc.b		0

bad_opt_msg:	.dc.b		'Bad option : '
		.dc.b		0

indir_err_msg:	.dc.b		'Indirect mode error',CRLF
		.dc.b		0

nf_indir_msg:	.dc.b		'Not found indirect file : '
		.dc.b		0

undef_env_lib:	.dc.b		"Undefined environment variable 'lib'",CRLF
		.dc.b		0

already_msg:	.dc.b		'Already read : '
		.dc.b		0

unknown_msg:	.dc.b		'Unknown command : '
		.dc.b		0

at_msg:		.dc.b		' at '
		.dc.b		0

in_msg:		.dc.b		' in '
		.dc.b		0

crlf:		.dc.b		CRLF,0

env_lib:	.dc.b		'lib',0

env_hlkev:	.dc.b		'HLK',0

ext_r:		.dc.b		'.r',0
ext_x:		.dc.b		'.x',0
ext_map:	.dc.b		'.map',0

		.even

*------------------------------------------------------------------------------
*
*	  -- size information table map --
*
*	+$0000	text size
*	+$0004	data size
*	+$0008	bss size
*	+$000c	comm size
*	+$0010	stack size
*	+$0014	rdata size
*	+$0018	rbss size
*	+$001c	rcomm size
*	+$0020	rstack size
*	+$0024	rldata size
*	+$0028	rlbss size
*	+$002c	rlcomm size
*	+$0030	rlstack size
*	+$0034	roffset size
*	+$0038
*	   .
*	   .	reserved
*	   .
*	+$0040
*
*------------------------------------------------------------------------------

obj_head:	.macro		code,name
		.dc		code
		.dc.l		0
		.dc.b		name,0
		.even
		.endm

*------------------------------------------------------------------------------

		.even

sys_info_name:	.dc.b		'*SYSTEM*',0
		.even

sys_info_h:	obj_head	$d000,'*SYSTEM*'
		obj_head	$c001,'text'
		obj_head	$c002,'data'
		obj_head	$c003,'bss'
		obj_head	$c004,'stack'
		obj_head	$c005,'rdata'
		obj_head	$c006,'rbss'
		obj_head	$c007,'rstack'
		obj_head	$c008,'rldata'
		obj_head	$c009,'rlbss'
		obj_head	$c00a,'rlstack'

sys_info_h_len:	.equ		*-sys_info_h
		.even

sz_info_lbl:	.dc		$b202
		.dc.l		$00000000
		.dc.b		'___size_info',0
		.even

sz_info_lbl_sz:	.equ		*-sz_info_lbl
		.even

rsize_lbl:	.dc		$b200
		.dc.l		$00000000
rsize_lbl_name:	.dc.b		'___rsize',0
		.even

rsize_lbl_sz:	.equ		*-rsize_lbl
		.even


* Block Storage Section ----------------------- *

		.bss
		.even

obj_size::	.ds.l		1

text_size::	.ds.l		1
data_size::	.ds.l		1
bss_size::	.ds.l		1
common_size::	.ds.l		1
stack_size::	.ds.l		1
rdata_size::	.ds.l		1
rbss_size::	.ds.l		1
rcommon_size::	.ds.l		1
rstack_size::	.ds.l		1
rldata_size::	.ds.l		1
rlbss_size::	.ds.l		1
rlcommon_size::	.ds.l		1
rlstack_size::	.ds.l		1

rdata_d_size::	.ds.l		1	;f[^ZNVɏo͂.rdata/.rldata
rldata_d_size::	.ds.l		1	;̂̃TCY(AC␳܂)

roff_tbl_adr::	.ds.l		1
roff_tbl_size::	.ds.l		1

common_pos::	.ds.l		1
rcommon_pos::	.ds.l		1
rlcommon_pos::	.ds.l		1

sys_info_adr:	.ds.l		1
sys_info_size:	.ds.l		1

obj_list_head::	.ds.l		1
obj_list_wp::	.ds.l		1

link_list_head::.ds.l		1
link_list_wp::	.ds.l		1

mem_start:	.ds.l		1
mem_end:	.ds.l		1
mem_left:	.ds.l		1

malloc_ptr_head::.ds.l		1		;malloc_*͏ԂςȂ!
malloc_ptr_tail::.ds.l		1
malloc_left::	 .ds.l		1

calc_stack_bot::.ds.l		1
calc_stack_top::.ds.l		1
calc_stack_ptr::.ds.l		1

hash_table::	.ds.l		1

exec_address::	.ds.l		1		;make_mapp
base_address::	.ds.l		1

search_path::	.ds.b		256

exec_name::	.ds.b		128
map_name::	.ds.b		128

temp:		.ds.b		512

exit_code::	.ds		1

title_flag:	.ds.b		1
indir_flag:	.ds.b		1
verbose_flag::	.ds.b		1
warnoff_flag::	.ds.b		1
cut_sym_flag::	.ds.b		1
loadmode::	.ds.b		1
mk_map_flag:	.ds.b		1
mk_sz_info_flag::
		.ds.b		1

no_x_ext_flag::	.ds.b		1
opt_an_flag::	.ds.b		1		;-an : st@Cw莞ɂ.xt

exec_file_type::.ds.b		1
opt_rn_flag::	.ds.b		1
		.even


		.end		main

* End of File --------------------------------- *
